"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * MDX default components
 */
var DEFAULTS = {
  inlineCode: 'code',
  wrapper: 'div'
};
/**
 * Renders final tag/component
 * @param {Vue.Component|String} type Element or tag to render
 * @param {Object|Array} props Props and attributes for element
 * @param {Array} children Array of child nodes for component
 */

function _default(type, props, children) {
  var h = this.createElement;
  var components = this.components;
  var defaults = Object.keys(DEFAULTS);
  var tag;
  var elProps = props; // We check context to see if the element/tag
  // is provided in the MDXProvider context.

  if (Object.keys(components).includes(type)) {
    // We check to see if props is of type object.
    // If it is, then we pass them into the MDXContext component
    var componentProps = _typeof(props) === 'object' ? props : undefined;
    tag = components[type](componentProps);
  } else if (defaults.includes(type)) {
    tag = DEFAULTS[type]; // Remove components object from attrs

    var _elProps$attrs = elProps.attrs,
        _components = _elProps$attrs.components,
        attrs = _objectWithoutProperties(_elProps$attrs, ["components"]);

    elProps = {
      attrs: attrs
    }; // Render final tag if component is not provided in context
  } else {
    tag = type;
  }

  return h(tag, elProps, children);
}